$(document).ready(function () {
    // START of album initialization
    var init_album_id = 43 // define the album 'ID' which should be started on initialization (MUST be top-level album due to the fact that parent-id is set to 'no')

    var init_id_full = 'album_' + init_album_id + '_parent_no';
    $(document.getElementById(init_id_full)).addClass('active'); // make the selected album on the left hand side 'active' (other style on the navbar)
    var init_album_path = document.getElementById(init_id_full).innerHTML;
    init_album_path = init_album_path.replace(/<span[^>]*>([^<]*)<\/span>/, '');
    init_album_path = init_album_path.replace('<i class="fa-solid fa-angle-right fa-xs"></i>', '');
    document.getElementById('album_title').innerHTML = '<h1>' + init_album_path + '</h1>';
    document.getElementById('outer_album_container').innerHTML = '<span id="inner_album_container"></span>';
    var init_album_count = document.getElementById('count_' + init_album_id).innerHTML;
    
    if (init_album_count != '(0)') {
        var init_album_function_name = 'album_' + init_album_id; // generate the funtion-name which will be called
        window[init_album_function_name]();
    };
    // END of album initialization
    
    
    // what to do when a link in the navbar is clicked
    $("#sidenav a").click(function() {
        var link = $(this);
        var closest_ul = link.closest("ul");
        var parallel_active_links = closest_ul.find(".active")
        var closest_li = link.closest("li");
        var link_status = closest_li.hasClass("active");
        var count = 0;
        
        closest_ul.find("ul").slideUp(function() {
            if (++count == closest_ul.find("ul").length)
                parallel_active_links.removeClass("active");
        });
        
        $('a').removeClass('active'); // remove all 'active' from a
        link.addClass('active'); // add 'active' to active a
        
        if (!link_status) {
            closest_li.children("ul").slideDown();
            closest_li.addClass("active");
        };
        
        // START open new album
        $('#inner_album_container').nanogallery2('destroy'); // destroy album
        
        var link_id = link[0].id;
        var album_id = link_id.split('_')[1];
        
        document.getElementById('outer_album_container').innerHTML = '<span id="inner_album_container"></span>';
        
        var album_count = document.getElementById('count_' + album_id).innerHTML;
        
        if (album_count != '(0)') {
            var album_function_name = 'album_' + album_id; // generate the funtion-name which will be called
            window[album_function_name]();
        };
        // END open new album
        
        // START generate the title on the right hand side
        album_path = document.getElementById(link_id).innerHTML; // name of the currently selected album
        album_path = album_path.replace(/<span[^>]*>([^<]*)<\/span>/, '');
        album_path = album_path.replace('<i class="fa-solid fa-angle-right fa-xs"></i>', '');
        var parent_album_id_part = link_id.split('_')[3]; // id of the parent album
        
        // check if below top level
        if (parent_album_id_part != 'no') {
            var parent_album_id_full = ''; // initialize
            var parent_album_title = ''; // initialize
            
            // loop as long until we are at the top level
            while (parent_album_id_part != 'no') {
                parent_album_id_full = document.querySelector('[id^="album_' + CSS.escape(parent_album_id_part) + '"]').id;
                parent_album_title = document.getElementById(parent_album_id_full).innerHTML; // name of the parent album
                
                album_path = parent_album_title + ' <span>&nbsp;>&nbsp;</span> ' + album_path; // generate the title on the right hand side above the album
                album_path = album_path.replace(/<span[^>]*>([^<]*)<\/span>/, '');
                album_path = album_path.replace('<i class="fa-solid fa-angle-right fa-xs"></i>', '');
                
                parent_album_id_part = parent_album_id_full.split('_')[3]; // go one level higher and get the new parent id (part)
            };
          
        };
        document.getElementById('album_title').innerHTML = '<h1>' + album_path + '</h1>';  
        // END generate the title on the right hand side
    });
});
